#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int int_fast64_t

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")

using namespace std;
using namespace __gnu_pbds;

const int INF = 2e18;

mt19937 rnd(1231);

gp_hash_table<int, int> sumleft;
gp_hash_table<int, int> sumright;
gp_hash_table<int, bool> rightt;
int a[15][15];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    int ty = 0;
    int mn = INF;
    int mx = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            ty += a[i][j];
            mn = min(mn, a[i][j]);
            mx = max(mx, a[i][j]);
        }
    }
    vector<int> link(1 << n);
    for (int i = 0; i < (1 << n); i++) {
        link[i] = i;
    }
//    shuffle(link.begin(), link.end(), rnd);
    int s;
    cin >> s;
    if (ty > s && ty - mn < s) {
        cout << "NO\n";
        return 0;
    }
    if (ty < s) {
        cout << "No\n";
        return 0;
    } else if (ty == s) {
        cout << "YES\n0";
        return 0;
    }
    bool swp = false;


    for (int i : link) {
        if (ty <= 1e4) {
            sumleft.clear();
            sumright.clear();
            rightt.clear();
            int sm = 0;
            for (int x = 0; x < n; x++) {
                if (i & (1 << x)) {
                    for (int y = 0; y < m; y++) {
                        sm += a[x][y];
                    }
                }
            }
            if (sm < s) continue;
            for (int j = 0; j < (1 << (m / 2)); ++j) {
                int now = 0;
                for (int x = 0; x < n; x++) {
                    for (int y = 0; y < m / 2; y++) {
                        if ((i & (1 << x)) && (j & (1 << y))) {
                            now += a[x][y];
                        }
                    }
                }
                sumleft[now] = j;
            }
            for (int j = 0; j < (1 << ((m + 1) / 2)); ++j) {
                int real = j << (m / 2);
                int now = 0;
                for (int x = 0; x < n; x++) {
                    for (int y = m / 2; y < m; y++) {
                        if ((i & (1 << x)) && (real & (1 << y))) {
                            now += a[x][y];
                        }
                    }
                }
                sumright[now] = real;
                rightt[now] = true;
            }

            for (auto [key, found]: sumleft) {
                if (s >= key && rightt[s - key]) {
                    int j = found | sumright[s - key];
                    cout << "YES\n";
                    int cnt = 0;
                    for (int x = 0; x < n; x++) {
                        if (!(i & (1 << x))) {
                            cnt++;
                        }
                    }
                    for (int y = 0; y < m; y++) {
                        if (!(j & (1 << y))) {
                            cnt++;
                        }
                    }
                    cout << cnt << "\n";
                    for (int x = 0; x < n; x++) {
                        if (!(i & (1 << x))) {
                            cout << "1 " << x + 1 << "\n";
                        }
                    }
                    for (int y = 0; y < m; y++) {
                        if (!(j & (1 << y))) {
                            cout << "2 " << y + 1 << "\n";
                        }
                    }
                    return 0;
                }
            }
        } else {
            vector<int> sum(m);
            int obs = 0;
            for (int x = 0; x < n; x++) {
                if (i & (1 << x)) {
                    for (int y = 0; y < m; y++) {
                        sum[y] += a[x][y];
                        obs += a[x][y];
                    }
                }
            }
            if (obs < s) continue;
            vector<vector<bool>> dp(m + 1, vector<bool>(obs + 1));
            dp[0][0] = true;
            for (int now = 1; now <= m; now++) {
                for (int cnt = 0; cnt <= obs; cnt++) {
                    dp[now][cnt] = dp[now - 1][cnt];
                    if (cnt >= sum[now - 1]) {
                        dp[now][cnt] = dp[now][cnt] || dp[now - 1][cnt - sum[now - 1]];
                    }
                }
            }
            if (dp[m][s]) {
                cout << "YES\n";
                vector<pair<string, int>> ans;
                int y = m;
                int now = s;
                while (y != 0) {
                    if (dp[y - 1][now - sum[y - 1]]) {
                        y--;
                        now -= sum[y];
                    } else {
                        ans.push_back({"2 ", y});
                        y--;
                    }
                }
                for (int x = 0; x < n; x++) {
                    if (!(i & (1 << x))) {
                        ans.push_back({"1 ", x + 1});
                    }
                }
                cout << ans.size() << "\n";
                for (auto [st, in] : ans) {
                    cout << st << in << "\n";
                }
                return 0;
            }
        }
    }
    cout << "NO\n";
}