#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int int_fast64_t

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

using namespace std;
using namespace __gnu_pbds;

const int INF = 2e18;

mt19937 rnd(1231);

vector<vector<int>> vec;
vector<int> pr;
vector<int> d;
int ttimer = 0;

void dfs(int v, int p) {
    d[v] = d[p] + 1;
    for (int u : vec[v]) {
        if (u != p) {
            dfs(u, v);
            pr[u] = v;
        }
    }
}




signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;
    int t;
    cin >> t;
    vec.resize(n);
    d.resize(n);
    pr.resize(n, -1);
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        vec[v].push_back(u);
        vec[u].push_back(v);
    }
    if (!t) {
        dfs(0, 0);
        set<pair<int, int>> st;
        vector<bool> post(n);
        for (int i = 0; i < n; i++) {
            st.insert({-d[i], i});
        }
        for (int i = 0; i < k; i++) {
            auto [v, dist] = *st.begin();
            st.erase(st.begin());
            int rst = 0;
            for (int j = 0; j <= dist / 2; j++) {
                rst++;
                v = pr[v];
                st.erase({-d[v], v});
                d[v] = min(d[v], rst);
                st.insert({-d[v], v});
            }
        }
        cout << -(*st.begin()).first << "\n";
    } else {
        for (int m = 0; m < n; m++) {
            d.clear();
            pr.clear();
            d.resize(n);
            pr.resize(n, -1);
            dfs(m, m);
            set<pair<int, int>> st;
            vector<bool> post(n);
            for (int i = 0; i < n; i++) {
                st.insert({-d[i], i});
            }
            for (int i = 0; i < k; i++) {
                auto [dist, v] = *st.begin();
                st.erase(st.begin());
                int rst = 0;
                for (int j = 0; j <= dist / 2; j++) {
                    rst++;
                    v = pr[v];
                    st.erase({-d[v], v});
                    d[v] = min(d[v], rst);
                    st.insert({-d[v], v});
                }
            }
            cout << -(*st.begin()).first - 1 << "\n";
        }
    }
}