#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int int_fast64_t

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")

using namespace std;
using namespace __gnu_pbds;

const int INF = 2e18;

mt19937 rnd(1231);

vector<vector<int>> vec;
vector<vector<int>> nw;
vector<int> pr;
vector<int> d;

void dfs(int v, int p) {
    d[v] = d[p] + 1;
    for (int u : vec[v]) {
        if (u != p) {
            dfs(u, v);
            pr[u] = v;
        }
    }
}




signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;
    int t;
    cin >> t;
    vec.resize(n);
    d.resize(n);
    pr.resize(n, -1);
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        vec[v].push_back(u);
        vec[u].push_back(v);
    }
    if (!t) {
        nw = vec;
        d.clear();
        pr.clear();
        d.resize(n, -1);
        pr.resize(n, -1);
        dfs(0, 0);
        vector<int> dst = d;
        vector<bool> post(n);
        post[0] = true;
        for (int x = 0; x < k; x++) {
            int dist = 0, v = 0;
            for (int i = 0; i < n; i++) {
                if (dst[i] > dist) {
                    dist = dst[i];
                    v = i;
                }
            }

            int govno = v;
            int rast = 0;
            while (!post[govno]) {
                govno = pr[govno];
                rast++;
            }
            rast /= 2;
            while (rast != 0) {
                rast--;
                v = pr[v];
            }

            nw[0].push_back(v);
            deque<int> q;
            q.push_back(v);
            dst[v] = 1;
            while (!q.empty()) {
                int now = q.front();
                q.pop_front();
                for (int u : nw[now]) {
                    if (dst[u] > dst[now] + 1) {
                        dst[u] = dst[now] + 1;
                        q.push_back(u);
                    }
                }
            }
        }
        int mx = 0;
        for (int i : dst) {
            mx = max(i, mx);
        }
        cout << mx << " ";
    } else {
        for (int m = 0; m < n; m++) {
            nw = vec;
            d.clear();
            pr.clear();
            d.resize(n, -1);
            pr.resize(n, -1);
            dfs(m, m);
            vector<int> dst = d;
            vector<bool> post(n);
            post[m] = true;
            for (int x = 0; x < k; x++) {
                int dist = 0, v = 0;
                for (int i = 0; i < n; i++) {
                    if (dst[i] > dist) {
                        dist = dst[i];
                        v = i;
                    }
                }

                int govno = v;
                int rast = 0;
                while (!post[govno]) {
                    govno = pr[govno];
                    rast++;
                }
                rast /= 2;
                while (rast != 0) {
                    rast--;
                    v = pr[v];
                }

                nw[m].push_back(v);
                deque<int> q;
                q.push_back(v);
                dst[v] = 1;
                while (!q.empty()) {
                    int now = q.front();
                    q.pop_front();
                    for (int u : nw[now]) {
                        if (dst[u] > dst[now] + 1) {
                            dst[u] = dst[now] + 1;
                            q.push_back(u);
                        }
                    }
                }
            }
            int mx = 0;
            for (int i : dst) {
                mx = max(i, mx);
            }
            cout << mx << " ";
        }
    }
}