#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int int_fast64_t

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

using namespace std;
using namespace __gnu_pbds;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    int s;
    cin >> s;
    gp_hash_table<int, bool> left;
    gp_hash_table<int, bool> right;
    map<int, int> up, down;
    map<int, bool> upok, downok;
    for (int i = 0; i < (1 << (n / 2)); i++) {
        left.clear();
        right.clear();
        for (int j = 0; j < (1 << (m / 2)); j++) {
            int now = 0;
            for (int x = 0; x < n; x++) {
                for (int y = 0; y < m / 2; y++) {
                    if ((i & (1 << x)) && (j & (1 << y))) {
                        now += a[x][y];
                    }
                }
            }
            left[now] = true;
        }
        for (int j = 0; j < (1 << ((m + 1) / 2)); j++) {
            int real = j << (m / 2);
            int now = 0;
            for (int x = 0; x < n; x++) {
                for (int y = m / 2; y < m; y++) {
                    if ((i & (1 << x)) && (real & (1 << y))) {
                        now += a[x][y];
                    }
                }
            }
            right[now] = true;
        }

        for (auto [key, found] : left) {
            for (auto [key1, found1] : right) {
                upok[key + key1] = true;
                up[key + key1] = i;
            }
        }
    }
    for (int i_ = 0; i_ < (1 << ((n + 1) / 2)); i_++) {
        int i = i_ << (n / 2);
        left.clear();
        right.clear();
        for (int j = 0; j < (1 << (m / 2)); j++) {
            int now = 0;
            for (int x = 0; x < n; x++) {
                for (int y = 0; y < m / 2; y++) {
                    if ((i & (1 << x)) && (j & (1 << y))) {
                        now += a[x][y];
                    }
                }
            }
            left[now] = true;
        }
        for (int j = 0; j < (1 << ((m + 1) / 2)); j++) {
            int real = j << (m / 2);
            int now = 0;
            for (int x = 0; x < n; x++) {
                for (int y = m / 2; y < m; y++) {
                    if ((i & (1 << x)) && (real & (1 << y))) {
                        now += a[x][y];
                    }
                }
            }
            right[now] = true;
        }

        for (auto [key, found] : left) {
            for (auto [key1, found1] : right) {
                downok[key + key1] = true;
                down[key + key1] = i;
            }
        }
    }

    for (auto [key, found] : up) {
        if (downok[s - key]) {
            int i = down[s - key] | found;
            for (int j = 0; j < (1 << m); j++) {
                int cnt = 0;
                int sum = 0;
                for (int x = 0; x < n; x++) {
                    for (int y = 0; y < n; y++) {
                        if ((i & (1 << x)) && (j & (1 << y))) {
                            sum += a[x][y];
                        }
                    }
                }
                if (sum == s) {
                    cout << "YES\n";
                    for (int x = 0; x < n; x++) {
                        if (!(i & (1 << x))) {
                            cnt++;
                        }
                    }
                    for (int y = 0; y < m; y++) {
                        if (!(j & (1 << y))) {
                            cnt++;
                        }
                    }
                    cout << cnt << '\n';
                    for (int x = 0; x < n; x++) {
                        if (!(i & (1 << x))) {
                            cout << "1 " << x + 1 << "\n";
                        }
                    }
                    for (int y = 0; y < m; y++) {
                        if (!(j & (1 << y))) {
                            cout << "2 " << y + 1 << '\n';
                        }
                    }
                    return 0;
                }
            }
        }
    }

    cout << "NO\n";
}