#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int int_fast64_t

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

using namespace std;
using namespace __gnu_pbds;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<int_fast32_t>> a(n, vector<int_fast32_t>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    int s;
    cin >> s;
    gp_hash_table<int, int_fast32_t> sumleft;
    gp_hash_table<int, int_fast32_t> sumright;
    gp_hash_table<int, bool> left;
    gp_hash_table<int, bool> right;
    for (int i = 0; i < (1 << n); i++) {
        sumleft.clear();
        sumright.clear();
        left.clear();
        right.clear();
        for (int_fast32_t j = 0; j < (1 << (m / 3)); j++) {
            int now = 0;
            for (int x = 0; x < n; x++) {
                for (int y = 0; y < m / 2; y++) {
                    if ((i & (1 << x)) && (j & (1 << y))) {
                        now += a[x][y];
                    }
                }
            }
            sumleft[now] = j;
            left[now] = true;
        }
        for (int_fast32_t j = 0; j < (1 << ((m + 2) / 3)); j++) {
            int_fast32_t real = j << (m / 3);
            int now = 0;
            for (int x = 0; x < n; x++) {
                for (int y = m / 2; y < m; y++) {
                    if ((i & (1 << x)) && (real & (1 << y))) {
                        now += a[x][y];
                    }
                }
            }
            sumright[now] = real;
            right[now] = true;
        }

        for (auto [key, found] : sumleft) {
            if (s >= key && right[s - key]) {
                int j = found | sumright[s - key];
                cout << "YES\n";
                int cnt = 0;
                for (int x = 0; x < n; x++) {
                    if (!(i & (1 << x))) {
                        cnt++;
                    }
                }
                for (int y = 0; y < m; y++) {
                    if (!(j & (1 << y))) {
                        cnt++;
                    }
                }
                cout << cnt << "\n";
                for (int x = 0; x < n; x++) {
                    if (!(i & (1 << x))) {
                        cout << "1 " << x + 1 << "\n";
                    }
                }
                for (int y = 0; y < m; y++) {
                    if (!(j & (1 << y))) {
                        cout << "2 " << y + 1 << "\n";
                    }
                }
                return 0;
            }
        }
    }
    cout << "NO\n";
}