#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long

using namespace std;
using namespace __gnu_pbds;

vector<bool> easy((int)1e6 + 1);

signed main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    unordered_map<int, bool> m1, m2;
    vector<int> ans(n);

    easy.assign((int)1e6 + 1, true);
    easy[1] = false;

    for (int i = 2; i <= 1e6; i++) {
        if (!easy[i]) continue;
        for (int j = i * i; j <= 1e6; j += i) {
            easy[j] = false;
        }
    }

    vector<pair<int, int>> sorted(n);
    for (int i = 0; i < n; i++) {
        sorted[i] = {a[i], i};
    }
    sort(sorted.begin(), sorted.end());


    for (auto [govn, i] : sorted) {
        int id = 2;
        int now = a[i];
        bool found = false;
        while (id * id <= a[i]) {
            if (now % id == 0) {
                if (m1[a[i] / id]) {
                    m2[a[i]] = true;
                    found = true;
                    ans[i] = 2;
                    break;
                }
                now /= id;
            } else {
                id++;
            }
        }
        if (now != 1) {
            if (m1[a[i] / now]) {
                m2[a[i]] = true;
                found = true;
                ans[i] = 2;
            }
        }
        if (!found) {
            m1[a[i]] = true;
            ans[i] = 1;
        }
    }

    for (int i : ans) {
        cout << i << " ";
    }
}